﻿Public Class Form1

    Dim _DtData As New DataTable
    Dim _dataLoaded As Boolean = False

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        BuildData()
        BindData()
        _dataLoaded = True
    End Sub

    Private Sub BuildData()

        Dim col1 As New DataColumn("BitColumn", GetType(Boolean))
        Dim col2 As New DataColumn("TextColumn", GetType(String))
        _DtData.Columns.Add(col1)
        _DtData.Columns.Add(col2)

        Dim row1 As DataRow = _DtData.NewRow
        row1.Item("BitColumn") = 1
        row1.Item("TextColumn") = "True Value"

        Dim row2 As DataRow = _DtData.NewRow
        row2.Item("BitColumn") = 0
        row2.Item("TextColumn") = "False Value"

        Dim row3 As DataRow = _DtData.NewRow
        row3.Item("BitColumn") = 0
        row3.Item("TextColumn") = "Another False Value"

        _DtData.Rows.Add(row1)
        _DtData.Rows.Add(row2)
        _DtData.Rows.Add(row3)
        _DtData.AcceptChanges()
    End Sub

    Private Sub BindData()
        Me.UltraGrid1.DataSource = _DtData
        Dim bndChecked As New Windows.Forms.Binding("CheckedValue", _DtData, "BitColumn")
        Dim bndChecked2 As New Windows.Forms.Binding("Checked", _DtData, "BitColumn")
        Dim bndText As New Windows.Forms.Binding("Text", _DtData, "TextColumn")
        bndText.DataSourceUpdateMode = DataSourceUpdateMode.OnPropertyChanged
        bndChecked.DataSourceUpdateMode = DataSourceUpdateMode.OnPropertyChanged
        Me.UltraCheckEditor1.DataBindings.Add(bndChecked)
        Me.CheckBox1.DataBindings.Add(bndChecked2)
        Me.UltraTextEditor1.DataBindings.Add(bndText)

    End Sub

    Private Sub UltraCheckEditor1_CheckedValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles UltraCheckEditor1.CheckedValueChanged
        If _dataLoaded Then Me.BindingContext(_DtData).EndCurrentEdit()
    End Sub

    Private Sub UltraTextEditor1_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles UltraTextEditor1.ValueChanged
        If _dataLoaded Then Me.BindingContext(_DtData).EndCurrentEdit()
    End Sub

    Private Sub CheckBox1_CheckStateChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckStateChanged
        If _dataLoaded Then Me.BindingContext(_DtData).EndCurrentEdit()

    End Sub

End Class
